package dk.brics.xact;

/**
 * Visitor for nodes.
 * All methods are empty unless overridden in a subclass.
 */
abstract public class NodeVisitor {
	
	/**
	 * Constructs a new visitor.
	 */
	public NodeVisitor() {}
	
	/**
	 * Visits an element node.
	 */
	public void visit(Element n) {}
	
	/**
	 * Visits a text node.
	 */
	public void visit(Text n) {}
	
	/**
	 * Visits a comment node.
	 */
	public void visit(Comment n) {}
	
	/**
	 * Visits a processing instruction node.
	 */
	public void visit(ProcessingInstruction n) {}
	
	/**
	 * Visits an attribute node.
	 */
	public void visit(Attribute n) {}
	
	/**
	 * Visits a template gap node.
	 */
	public void visit(TemplateGap n) {}
	
	/**
	 * Visits an attribute gap node.
	 */
	public void visit(AttributeGap n) {}
	
	/**
	 * Visits an namespace declaration node.
	 */
	public void visit(NamespaceDecl n) {}
}
