package dk.brics.xact;

/**
 * Visitor for nodes that takes an additional parameter and returns a value.
 * All methods are empty unless overridden in a subclass.
 */
abstract public class NodeVisitorParameterized<Return,Argument> {
	
	/**
	 * Constructs a new visitor.
	 */
	public NodeVisitorParameterized() {}
	
	/**
	 * Visits an element node.
	 */
	public Return visit(Element n, Argument arg) {
		return null;
	}
	
	/**
	 * Visits a text node.
	 */
	public Return visit(Text n, Argument arg) {
		return null;
	}
	
	/**
	 * Visits a comment node.
	 */
	public Return visit(Comment n, Argument arg) {
		return null;
	}
	
	/**
	 * Visits a processing instruction node.
	 */
	public Return visit(ProcessingInstruction n, Argument arg) {
		return null;
	}
	
	/**
	 * Visits an attribute node.
	 */
	public Return visit(Attribute n, Argument arg) {
		return null;
	}
	
	/**
	 * Visits a template gap node.
	 */
	public Return visit(TemplateGap n, Argument arg) {
		return null;
	}
	
	/**
	 * Visits an attribute gap node.
	 */
	public Return visit(AttributeGap n, Argument arg) {
		return null;
	}
	
	/**
	 * Visits an namespace declaration node.
	 */
	public Return visit(NamespaceDecl n, Argument arg) {
		return null;
	}
}
