package dk.brics.xact;

import dk.brics.misc.Origin;

/**
 * Base class for plug operation nodes.
 */
abstract class PlugNode extends OperationNode {

	private final XML self;
	
	private final String gap;
	
	/**
	 * Constructs a new plug node.
	 */
	PlugNode(XML self, String gap, Origin origin) {
		super(origin);
		this.self = self;
		this.gap = gap;
	}
	
	/**
	 * Returns the self node.
	 */
	public XML getSelfNode() {
		return self;
	}

	/**
	 * Returns the gap name.
	 */
	public String getGap() {
		return gap;
	}
}
