package dk.brics.xact;

import dk.brics.misc.Origin;

/**
 * Base class for template nodes.
 */
abstract public class TempNode extends XML {

	private final XML nextsibling;

	TempNode(XML nextsibling, Origin origin) {
		super(origin);
		this.nextsibling = nextsibling;
	}

	@Override
	abstract void visitNormalizedBy(NodeVisitor v);

	@Override
	public XML getNextSibling() {
		return normalize(nextsibling);
	}
	
	@Override
	XML getRealNextSibling() {
		return follow(nextsibling);
	}
	
	/**
	 * Returns a copy of this node with the given next sibling.
	 */
	abstract public TempNode copy(XML nextsibling);
}
