package dk.brics.xact.analysis.flowgraph;

import dk.brics.misc.Origin;

/** 
 * Superclass of all program entities.
 */
public abstract class Entity {

	private Origin origin;
	
	/** 
	 * Constructs a new node.
	 */
	public Entity(Origin origin) {
		this.origin = origin;
	}
	
	/**
	 * Returns the origin.
	 */
	public Origin getOrigin() {
		return origin;
	}
	
	/** 
	 * Returns a textual representation of the node.
	 * Includes the origin.
	 */
	@Override
	public String toString() {
		return origin.getFile() + " line " + origin.getLine();
	}
}
