package dk.brics.xact.analysis.flowgraph;

import java.util.Map;

import dk.brics.misc.Origin;
import dk.brics.xact.XML;
import dk.brics.xmlgraph.XMLGraphFragment;

/**
 * XML template constant.
 */
public class TemplateConstant extends Entity {
	
	private String template;
	private Map<String,String> namespaces;
	private XMLGraphFragment fragment;
	private XML xml;
	
	/**
	 * Constructs a new template constant.
	 */
	public TemplateConstant(String template, Map<String,String> namespaces, Origin origin) {
		super(origin);
		this.template = template;
		this.namespaces = namespaces;
	}
	
	@Override
	public String toString() {
		return "template constant [[" + template + "]] at " + super.toString();
	} 
	
	/**
	 * Returns the template constant string.
	 */
	public String getTemplate() {
		return template;
	}
	
	public XMLGraphFragment getFragment() {
        return fragment;
    }
	
	public void setFragment(XMLGraphFragment fragment) {
        this.fragment = fragment;
    }
	
	public XML getXML() {
        return xml;
    }
	
    public void setXML(XML xml) {
        this.xml = xml;
    }

    /**
	 * Returns the namespace map.
	 */
	public Map<String,String> getNamespaces() {
		return namespaces;
	}
}
