package dk.brics.xact.analysis.flowgraph.statements;

import dk.brics.misc.Origin;
import dk.brics.xact.analysis.flowgraph.Variable;

public class ArrayWriteStm extends Assignment {
	
	private Variable source;
	
	public ArrayWriteStm(Variable dest, Variable source, Origin origin) {
		super(dest, origin);
		this.source = source;
	}
	
	@Override
	public String getOpName() {
		return "arraywrite";
	}

	@Override
	public void visitBy(StatementVisitor v) {
		v.visitArrayWriteStm(this);
	}

	public Variable getSource() {
		return source;
	}

	public void setSource(Variable source) {
		this.source = source;
	}
	
	@Override
	public String toString() {
		return source + " => " + getDest() + "[] at " + getOrigin().getFile() + " line " + getOrigin().getLine();
	}
	
}
