package dk.brics.xact.analysis.flowgraph.statements;

import dk.brics.automaton.Automaton;
import dk.brics.misc.Origin;
import dk.brics.xact.analysis.flowgraph.Variable;
import dk.brics.xact.analysis.util.Util;

public class ArrayWriteStringStm extends Assignment {
	
	private Automaton stringsrc;

	public ArrayWriteStringStm(Variable dest, Automaton stringsrc, Origin origin) {
		super(dest, origin);
		this.stringsrc = stringsrc;
	}

	public Automaton getStringsrc() {
		return stringsrc;
	}

	public void setStringsrc(Automaton stringsrc) {
		this.stringsrc = stringsrc;
	}

	@Override
	public String getOpName() {
		return "arraywritestring";
	}

	@Override
	public void visitBy(StatementVisitor v) {
		v.visitArrayWriteStringStm(this);
	}
	
	@Override
	public String toString() {
		return Util.getAutomatonDescription(stringsrc) + super.toString();
	}
	
}
