package dk.brics.xact.analysis.flowgraph.statements;

import dk.brics.misc.Origin;
import dk.brics.xact.analysis.flowgraph.TemplateConstant;
import dk.brics.xact.analysis.flowgraph.Variable;

/**
 * Assignment of {@link dk.brics.xact.XML#parseTemplate(String)} and variants.
 */
public class ConstStm extends Assignment {
	
	private TemplateConstant template;

	/**
	 * Constructs a new <code>ConstStm</code> object.
	 */
	public ConstStm(Variable dest, TemplateConstant template, Origin origin) {
		super(dest, origin);
		this.template = template;
	}

	/**
	 * Returns the template template constant.
	 */
	public TemplateConstant getConst() {
		return template;
	}
	
	@Override
	public void visitBy(StatementVisitor v) { 
		v.visitConstStm(this); 
	}
	
	@Override
	public String toString() {
		return "constant" + super.toString();
	}
	
	@Override
	public String getOpName() {
		return "parseTemplate";
	}
}
