package dk.brics.xact.analysis.flowgraph.statements;

import dk.brics.misc.Origin;
import dk.brics.xact.analysis.flowgraph.Variable;

/** 
 * Assignment of empty value, such as <code>null</code> or an empty array.
 */
public class EmptyStm extends Assignment { // TODO: do we really need EmptyStm?
	
	private boolean array;
	
	/** 
	 * Constructs a new <code>EmptyStm</code> object.
	 */
	public EmptyStm(Variable dest, boolean array, Origin origin) {
		super(dest, origin);
		this.array = array;
	}
	
	/**
	 * Returns true if this is a new (empty) array being created.
	 */
	public boolean isArray() {
		return array;
	}
	
	@Override
	public void visitBy(StatementVisitor v) { 
		v.visitEmptyStm(this); 
	}
	
	@Override
	public String toString() {
		return "empty" + super.toString();
	}
	
	@Override
	public String getOpName() {
		return "empty";
	}
}
