package dk.brics.xact.analysis.flowgraph.statements;

import dk.brics.misc.Origin;
import dk.brics.xact.analysis.flowgraph.Statement;
import dk.brics.xact.analysis.flowgraph.Variable;

public class EscapeStm extends Statement {
	
	private Variable var;
	
	public EscapeStm(Variable var, Origin origin) {
		super(origin);
		this.var = var;
	}
	
	@Override
	public String getOpName() {
		return "escape";
	}

	@Override
	public void visitBy(StatementVisitor v) {
		v.visitEscapeStm(this);
	}

	public Variable getVar() {
		return var;
	}

	public void setVar(Variable var) {
		this.var = var;
	}
	
	@Override
	public String toString() {
		return "escape " + var + " at " + super.toString();
	}
	
}
