package dk.brics.xact.analysis.flowgraph.statements;

import dk.brics.misc.Origin;
import dk.brics.xact.analysis.flowgraph.Variable;

/**
 * Superclass of abstract statements that are assignments involving a non-static method.
 */
abstract public class InstanceAssignment extends Assignment {
	
	/** 
	 * The XML variable containing the base value.
	 */
	private Variable base;

	/** 
	 * Constructs a new <code>InstanceAssignment</code> object.
	 */
	public InstanceAssignment(Variable dest, Variable base, Origin origin) {
		super(dest, origin);
		this.base = base;
	}

	/**
	 * Returns the base variable.
	 */
	public Variable getBase() {
		return base;
	}
	
	/**
	 * Sets the base variable.
	 */
	public void setBase(Variable base) {
		this.base = base;
	}
}
