package dk.brics.xact.analysis.flowgraph.statements;

import dk.brics.misc.Origin;
import dk.brics.xact.analysis.flowgraph.Variable;

/**
 * Assignment of {@link dk.brics.xact.XML#remove(String)}.
 */
public class RemoveStm extends InstanceAssignment {
	
	/** 
	 * The XPath expression.
	 */
	private String xpath;
	
	/** 
	 * Constructs a new <code>RemoveStm</code> object.
	 */
	public RemoveStm(Variable dest, Variable base, String xpath, Origin origin) {
		super(dest, base, origin);
		this.xpath = xpath;
	}

	/**
	 * Returns the XPath expression.
	 */
	public String getXPath() {
		return xpath;
	}
	
	@Override
	public void visitBy(StatementVisitor v) { 
		v.visitRemoveStm(this); 
	}
	
	@Override
	public String toString() {
		return "remove(" + xpath + ")" + super.toString();
	}
	
	@Override
	public String getOpName() {
		return "remove";
	}
}
