package dk.brics.xact.analysis.flowgraph.statements;

import dk.brics.misc.Origin;
import dk.brics.xact.analysis.flowgraph.Variable;

/** 
 * Assignment of an unknown value, such as {@link dk.brics.xact.XML#parseDocument(String)} and variants.
 */
public class UnknownStm extends Assignment {
	
	/** 
	 * Constructs a new <code>UnknownStm</code> object.
	 */
	public UnknownStm(Variable dest, Origin origin) {
		super(dest, origin);
	}
	
	@Override
	public void visitBy(StatementVisitor v) { 
		v.visitUnknownStm(this); 
	}
	
	@Override
	public String toString() {
		return "unknown" + super.toString();
	}
	
	@Override
	public String getOpName() {
		return "unknown";
	}
}
