package dk.brics.xact.analysis.soot;

import java.util.Map;

import soot.ValueBox;
import dk.brics.xact.analysis.flowgraph.FlowGraph;
import dk.brics.xact.analysis.flowgraph.statements.AnalyzeStm;

/**
 * The result of translating a soot program to XACT's flow graph representation.
 * Contains the flow graph, and a map from hotspot expressions to their flow graph
 * representations.
 * 
 * @author Asger
 */
public class TranslationResult {
	private FlowGraph graph;
	private Map<ValueBox,AnalyzeStm> hotspots;
	
	public TranslationResult(FlowGraph graph, Map<ValueBox, AnalyzeStm> hotspots) {
		this.graph = graph;
		this.hotspots = hotspots;
	}

	public FlowGraph getGraph() {
		return graph;
	}

	public Map<ValueBox, AnalyzeStm> getHotspots() {
		return hotspots;
	}
}
