package dk.brics.xact.operations;

import java.io.OutputStream;

/**
 * Output stream that counts the number of bytes written.
 */
public class LengthOutputStream extends OutputStream {

	private int length;
	
	/**
	 * Constructs a new length output stream.
	 */
	public LengthOutputStream() {}
	
	/**
	 * Writes a byte.
	 */
	@Override
	public void write(int b) {
		length++;
	}
	
	/**
	 * Resets the byte counter.
	 */
	public void reset() {
		length = 0;
	}
	
	/**
	 * Returns the number of bytes written.
	 */
	public int getLength() {
		return length;
	}
}
