package dk.brics.xact.operations;

import javax.xml.transform.sax.SAXResult;

import dk.brics.xact.XML;

/**
 * Result class for XSL transformations. The class extends SAXResult and may therefore be used
 * in combination with {@link dk.brics.xact.operations.XMLSource} to make XSL transformations 
 * through the standard JAXP classes.
 *
 * @author Mathias Schwarz
 */
public class XMLResult extends SAXResult {

	private ParseHandler h = new ParseHandler(null);

	/**
	 * Constructs a new <code>XMLResult</code> object.
	 */
    public XMLResult() {
        setHandler(h);
    }

    /**
     * Returns the resulting XML template.
     */
    public XML getResult() {
        return h.getRoot();
    }
}
